var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var tfcommand_1 = require("../../lib/tfcommand");
var args = require("../../lib/arguments");
function getCommand(args) {
    return new WorkItemBase(args);
}
exports.getCommand = getCommand;
var WorkItemBase = (function (_super) {
    __extends(WorkItemBase, _super);
    function WorkItemBase() {
        _super.apply(this, arguments);
        this.description = "Commands for managing Work Items.";
    }
    WorkItemBase.prototype.setCommandArgs = function () {
        _super.prototype.setCommandArgs.call(this);
        this.registerCommandArgument("workItemId", "Work Item ID", "Identifies a particular Work Item.", args.IntArgument);
        this.registerCommandArgument("query", "Work Item Query (WIQL)", null, args.StringArgument);
        this.registerCommandArgument("workItemType", "Work Item Type", "Type of Work Item to create.", args.StringArgument);
        this.registerCommandArgument("assignedTo", "Assign To", "Who to assign the Work Item to.", args.StringArgument);
        this.registerCommandArgument("title", "Work Item Title", "Title of the Work Item.", args.StringArgument);
        this.registerCommandArgument("description", "Work Item Description", "Description of the Work Item.", args.StringArgument);
    };
    WorkItemBase.prototype.exec = function (cmd) {
        return this.getHelp(cmd);
    };
    return WorkItemBase;
})(tfcommand_1.TfCommand);
exports.WorkItemBase = WorkItemBase;
