var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var os_1 = require("os");
var trace = require("../../lib/trace");
var witBase = require("./default");
function getCommand(args) {
    return new WorkItemShow(args);
}
exports.getCommand = getCommand;
var WorkItemShow = (function (_super) {
    __extends(WorkItemShow, _super);
    function WorkItemShow() {
        _super.apply(this, arguments);
        this.description = "Show Work Item details.";
    }
    WorkItemShow.prototype.getHelpArgs = function () {
        return ["workItemId"];
    };
    WorkItemShow.prototype.exec = function () {
        var witapi = this.webApi.getQWorkItemTrackingApi();
        return this.commandArgs.workItemId.val().then(function (workItemId) {
            return witapi.getWorkItem(workItemId);
        });
    };
    WorkItemShow.prototype.friendlyOutput = function (data) {
        if (!data) {
            throw new Error("no results");
        }
        var workItem = data;
        trace.info(os_1.EOL);
        trace.info("id:          " + workItem.id);
        trace.info("rev:         " + workItem.rev);
        trace.info("type:        " + workItem.fields["System.WorkItemType"]);
        trace.info("state:       " + workItem.fields["System.State"]);
        trace.info("title:       " + workItem.fields["System.Title"]);
        trace.info("assigned to: " + workItem.fields["System.AssignedTo"]);
    };
    return WorkItemShow;
})(witBase.WorkItemBase);
exports.WorkItemShow = WorkItemShow;
